/*
	(TCB)
	Timely Execution Demo Application	
	
--[TCB 0.1]---------------------------------------------------

(C) 1999-2001
    Navigators Group - www.navigators.di.fc.ul.pt

       Pedro Martins        Antonio Casimiro    Paulo Verissimo     
    pmartins@di.fc.ul.pt    casim@di.fc.ul.pt   pjv@di.fc.ul.pt    

--------------------------------------------------------------- 			
*/
	
	
#include "tcb.h"

int main()
{
	int tcbDesc,res,wiDesc,ret;
	TCBtimestamp start_evt,end_evt;
	TCBtimeinterval delay,max_exec;
	Func_Id funcId;
	
	// open a conection to TCB
	if ( (ret=openTCBConnection(&tcbDesc,&wiDesc))<OK)
	{
		printTCBerror(ret);
		exit(1);
	}
	
	start_evt=getTCBTimestamp(tcbDesc);
	
	if (start_evt==TCB_ACESS_ERROR)
	{		
		printTCBerror((int)start_evt);
		printf("\n");
		closeTCBConnection(tcbDesc,wiDesc);
		exit(1);
	}
	
	delay=1000000000;       // 1 second
	max_exec=1000000000;	// 1 second
	strcpy(funcId.module,"app_module");
	strcpy(funcId.funcname,"timelyExec");
	strcpy(funcId.wcetname,"timelyExec_wcet");
	
	end_evt=startTCBExec(tcbDesc,start_evt,delay,max_exec,funcId,"");
	
	if (end_evt<0)
	{	
		printTCBerror((int)end_evt);
		printf("\n");
		closeTCBConnection(tcbDesc,wiDesc);
		exit(1);	
	}	
				
	closeTCBConnection(tcbDesc,wiDesc);
	
	return 0;
}