#ifndef MODULE
#define MODULE
#endif

#include <linux/module.h>
#include "TCBnetdev.h"

TCBnetdev devt;
struct module *drvmodule;
int MTU=-1;

// send a time replicated message - broadcast
int sendMessage(void * buff, int len, unsigned char count)
{
	if (MTU==-1)
	 MTU=devt.getMTU();
	if (len<=MTU)
	return devt.send(buff,len,count);
	 else
	  return -1;
}

int readMessage(void* buff,hrtime_t* rcvTime)
{
	return devt.read(buff,rcvTime);
}

//VER MELHOR ->antes do primeiro envio nao da!!!!
int getNetMTU(void)
{
	return devt.getMTU();
}

unsigned long getMacAddr(void)
{
	return devt.getMacAddr();
}

void startReceive(void)
{
	devt.startReceive();
}

void stopReceive(void)
{
	devt.stopReceive();
}

// driver upcall
TCBnetdev* registerTCBnetdevice(char* name,struct module* drvmod)
{		
	drvmodule=drvmod;
	return &devt;
}


int init_module(void)
{	
	return 0;  
}


void cleanup_module(void)
{
}