/*
--[TCB 0.1]---------------------------------------------------

(C) 1999-2001
    Navigators Group - www.navigators.di.fc.ul.pt

       Pedro Martins        Antonio Casimiro    Paulo Verissimo     
    pmartins@di.fc.ul.pt    casim@di.fc.ul.pt   pjv@di.fc.ul.pt    

--------------------------------------------------------------- 		
*/


#include "control.h"
#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/ioctl.h>
#include <sys/types.h>
#include <sys/time.h>
#include <sys/signal.h>

int fd0;

void init_simul()
{
	int msg;

	if ((fd0 = open("/dev/rtf23", O_WRONLY)) < 0) {
		fprintf(stderr, "Error opening /dev/rtf23\n");
		exit(1);
	}

	msg= START_TASK;
	if (write(fd0, &msg, sizeof(msg)) < 0) {
		fprintf(stderr, "Can't send a command to RT-task\n");
		exit(1);
	}
}

void sig_int(int s)
{
	int msg;

	msg= STOP_TASK;
	if (write(fd0, &msg, sizeof(msg)) < 0) {
		fprintf(stderr, "Can't send a command to RT-task\n");
	}

	exit(0);
}

int s=0;

void control_com(int f)
{
	s=1;
}

void control()
{
	int msg=REFRESH;
	struct itimerval value;

	value.it_value.tv_sec=1;
	value.it_value.tv_usec=40000;   // you must adjust this parameter
					// to your system ... try to find your
				        // execution time limit		
	value.it_interval.tv_sec=0;
	value.it_interval.tv_usec=0;
	
	write(fd0, &msg, sizeof(msg));			
	
	s=0;
	setitimer(ITIMER_REAL,&value,0);	
	while (s==0){};
}


int main()
{
	printf("During the execution press <ctrl+c> to exit\n");
	printf("Press <enter> to continue\n");
	getchar();
	
	signal(SIGALRM,control_com);
	signal(SIGINT,sig_int);
	
	init_simul();
	
	while (1)
	{
		
	control();
	
	}
	
	
	return 0;
}