/*
	(TCB)
	HelloWorld application
	
--[TCB 0.1]---------------------------------------------------

(C) 1999-2001
    Navigators Group - www.navigators.di.fc.ul.pt

       Pedro Martins        Antonio Casimiro    Paulo Verissimo     
    pmartins@di.fc.ul.pt    casim@di.fc.ul.pt   pjv@di.fc.ul.pt    

--------------------------------------------------------------- 		

*/	
	
#include "tcb.h"
#include <sys/time.h>


int tcbDesc,wiDesc;

int main()
{
	TCBtimestamp start_evt;
	int tcb_id;
	int ret;
	
	
	// open a conection to TCB
	if ( (ret=openTCBConnection(&tcbDesc,&wiDesc))<OK)
	{
		printTCBerror(ret);
		exit(1);
	}
	
	// get local TCB id
	
	tcb_id=getTCBid(tcbDesc);
	
	printf("Conection to TCB local node (%u) established\n",tcb_id);
		
	start_evt=getTCBTimestamp(tcbDesc);
	
	printf("A TCB timestamp : %lld\n",start_evt);	
		
	
	closeTCBConnection(tcbDesc,wiDesc);
	
	return 0;
}